#include <iostream>
#include <vector>
#include <ctime>
#include <stdio.h>
#include <string.h>

#define MOD 1000000007
#define MAX 131072
#define MAX_LETTERS 26
#define MAX_DISTANCE 10

#define DEBUG_INFO 0

using namespace std;

int n;
int dyn[MAX_LETTERS][MAX];
int dist[MAX_LETTERS][MAX_LETTERS];


int main(void)
{
	unsigned sTime;
	FILE *in = stdin; FILE *out = stdout;

	if (DEBUG_INFO)
	{
		sTime = clock();
		in = fopen("reading.in", "rt"); out = fopen("reading.out", "wt");
	}

	for (int i=0; i<MAX_LETTERS; i++)
		for (int c=0; c<MAX_LETTERS; c++) dist[i][c] = 1;

	int n, m;
	fscanf(in, "%d %d", &n, &m);
	for (int i=0; i<m; i++)
	{
		int distance;
		char let1[4], let2[4];
		fscanf(in, "%s %s %d", let1, let2, &distance);
		dist[let1[0] - 'a'][let2[0] - 'a'] = distance;
		dist[let2[0] - 'a'][let1[0] - 'a'] = distance;
	}

	int ans = 0;
	int idx = MAX_DISTANCE;
	memset(dyn, 0, sizeof(dyn));
	for (int i=0; i<MAX_LETTERS; i++) {dyn[i][idx] = 1; ans++;}

	while (n--)
	{
		idx++;
		if (idx >= MAX)
		{
			for (int i=0; i<MAX_LETTERS; i++)
				for (int c=0; c<MAX_DISTANCE; c++)
					dyn[i][c] = dyn[i][MAX-MAX_DISTANCE+c];
			idx = MAX_DISTANCE;
		}

		for (int i=0; i<MAX_LETTERS; i++)
		{
			dyn[i][idx] = 0;
			for (int c=0; c<MAX_LETTERS; c++)
			{
				dyn[i][idx] += dyn[c][idx - dist[i][c]];
				if (dyn[i][idx] >= MOD) dyn[i][idx] -= MOD;
			}
			ans = (ans + dyn[i][idx]) % MOD;
		}
	}
	fprintf(out, "%d\n", ans);

	if (DEBUG_INFO)
	{
		unsigned eTime = clock();
		cout << "Execution time: " << (double)(eTime - sTime) / (double)CLOCKS_PER_SEC << endl;

	}
	return 0;
}
